#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

vector <int> V;
vector <int> lit;
int N, L, M, segs;

void solve1();
void solve2();
void solve3();

int main() {
	freopen("gate.in", "r", stdin);
	freopen("gate.out", "w", stdout);
	int i, t;

	scanf("%d %d %d", &N, &L, &M);
	V.resize(N + 1);
	lit.resize(N + 1);
	for (i = 2; i <= N; ++i) {
		lit[i] = lit[i - 1] + 1;
		lit[i] %= L;
	}
	for (i = 0; i < M; ++i){
		scanf("%d", &t);
		if (t == 1) 
			solve1();
		else if (t == 2) 
			solve2();
		else 
			solve3();
	}
	return 0;
}

void solve1() {
	int poz, i;
	scanf("%d", &poz);
	if (poz < N && V[poz + 1] != V[poz]) return;
	++segs;
	int old = V[poz];
	for (i = poz; i > 0 && V[i] == old; --i){
		V[i] = segs;
	}
 }


void solve2() {
	int poz, pas, old, i;
	scanf("%d %d", &poz, &pas);
	old = V[poz];
	if (pas < 0) {
		pas = abs(pas);
		pas %= L;
		pas = -pas;
	}
	pas += L;
	for (i = poz; i && V[i] == old; --i) {
		
		lit[i] += pas;
		lit[i] %= L;
	}
	for (i = poz + 1; i <= N && V[i] == old; ++i) {
		lit[i] += pas;
		lit[i] %= L;
	}
}

void solve3() {
	int poz;
	scanf("%d", &poz);
	printf("%c\n", (char) ('a' + lit[poz]));
}